SystemOrganization addCategory: #'GSoC-Spreadsheet'!

Player subclass: #SpreadsheetPlayer
	instanceVariableNames: 'rowIndex columnIndex fileName separator'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GSoC-Spreadsheet'!

!SpreadsheetPlayer class methodsFor: 'change set logging' stamp: 'Richo 7/9/2010 15:14'!
isUniClass
	^ self ~~ self officialClass! !

!SpreadsheetPlayer class methodsFor: 'change set logging' stamp: 'Richo 7/9/2010 15:15'!
officialClass
	^ SpreadsheetPlayer! !

!SpreadsheetPlayer class methodsFor: 'change set logging' stamp: 'Richo 7/9/2010 15:15'!
wantsChangeSetLogging
	^ (self == self officialClass
			or: [(self name beginsWith: self officialClass asString) not])
		or: [Preferences universalTiles]! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/29/2010 00:41'!
clearColumn
[^self costume renderedMorph clearColumn: self getColumnIndex] on: Error do: [:err| self inform: err description]! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/29/2010 00:41'!
clearRow
[^self costume renderedMorph clearRow: self getRowIndex] on: Error do: [:err| self inform: err description]! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/29/2010 00:35'!
clearTable
^self costume renderedMorph clearTable! !

!SpreadsheetPlayer methodsFor: 'file i/o' stamp: 'Richo 7/26/2010 16:29'!
exportDataToFile
[self costume renderedMorph saveCSVFile: fileName separator: separator] on: Error do: [:err| ^self inform: 'File error']! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/18/2010 11:07'!
getColumnIndex
columnIndex > self getTotalColumns ifTrue: [columnIndex := self getTotalColumns].
^ columnIndex! !

!SpreadsheetPlayer methodsFor: 'file i/o' stamp: 'Richo 6/17/2010 22:34'!
getCsvFileName
	^fileName! !

!SpreadsheetPlayer methodsFor: 'file i/o' stamp: 'Richo 6/18/2010 11:54'!
getCsvSeparator
^separator asString! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/18/2010 11:24'!
getCurrentCharacters
^self costume renderedMorph cellValueAt: self getRowIndex @ self getColumnIndex! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/18/2010 11:24'!
getCurrentNumericValue
^self costume renderedMorph cellNumericValueAt: self getRowIndex @ self getColumnIndex! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/18/2010 11:07'!
getRowIndex
rowIndex > self getTotalRows ifTrue: [rowIndex := self getTotalRows].
^ rowIndex! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/18/2010 10:59'!
getTotalColumns
^self costume renderedMorph numberOfColumns! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/18/2010 10:59'!
getTotalRows
^self costume renderedMorph numberOfRows! !

!SpreadsheetPlayer methodsFor: 'file i/o' stamp: 'Richo 6/29/2010 11:27'!
getWriteMode
^self costume renderedMorph overwrite ifTrue: [#overwrite] ifFalse: [#append]! !

!SpreadsheetPlayer methodsFor: 'file i/o' stamp: 'Richo 7/26/2010 17:13'!
importDataFromFile
[[self costume renderedMorph openCSVFile: fileName separator: separator] 
on: FileDoesNotExistException do: [:err | self inform: 'The file doesn''t exist.']]
on: Error do: [:err | self inform: 'An error occurred. Please check if the file''s format is CSV.'].! !

!SpreadsheetPlayer methodsFor: 'initialize' stamp: 'Richo 6/18/2010 11:06'!
initialize
super initialize.
rowIndex := 1.
columnIndex := 1.
separator := $,.
fileName := 'fileName.csv'! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/18/2010 11:08'!
setColumnIndex: aNumber 
(aNumber > self getTotalColumns)
	ifTrue: [columnIndex := 1.^self].
aNumber < 1
	ifTrue: [columnIndex := self getTotalColumns.^self].
columnIndex := aNumber.! !

!SpreadsheetPlayer methodsFor: 'file i/o' stamp: 'Richo 6/17/2010 22:36'!
setCsvFileName: aString
	fileName := aString! !

!SpreadsheetPlayer methodsFor: 'file i/o' stamp: 'Richo 6/19/2010 12:41'!
setCsvSeparator: aString
separator := aString at: 1 ifAbsent: [$,]! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/18/2010 11:25'!
setCurrentCharacters: aString
^self costume renderedMorph cellValueAt: self getRowIndex @ self getColumnIndex put: aString! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/18/2010 11:25'!
setCurrentNumericValue: aNumber
^self costume renderedMorph cellNumericValueAt: self getRowIndex @ self getColumnIndex put: aNumber! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/18/2010 11:08'!
setRowIndex: aNumber 
(aNumber > self getTotalRows)
	ifTrue: [rowIndex := 1.^self].
aNumber < 1
	ifTrue: [rowIndex := self getTotalRows.^self].
rowIndex := aNumber.! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/18/2010 10:59'!
setTotalColumns: aNumber
^self costume renderedMorph numberOfColumns: (aNumber max: 1)! !

!SpreadsheetPlayer methodsFor: 'spreadsheet' stamp: 'Richo 6/18/2010 10:59'!
setTotalRows: aNumber
^self costume renderedMorph numberOfRows: (aNumber max: 1)! !

!SpreadsheetPlayer methodsFor: 'file i/o' stamp: 'Richo 6/29/2010 11:28'!
setWriteMode: aSymbol
| morph |
morph := self costume renderedMorph.
aSymbol caseOf: {
	[#overwrite] -> [morph setOverwrite].
	[#append] -> [morph setAppend]
} otherwise: [].! !

Morph subclass: #ScrollableSpreadsheetMorph
	instanceVariableNames: 'spreadsheet scrollPane'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GSoC-Spreadsheet'!

!ScrollableSpreadsheetMorph class methodsFor: 'viewer categories' stamp: 'Richo 6/18/2010 17:10'!
additionsToViewerCategories
^ (Smalltalk at: #SpreadsheetMorph ifAbsent: [^#()]) additionsToViewerCategories ! !

!ScrollableSpreadsheetMorph class methodsFor: 'parts bin' stamp: 'Richo 6/17/2010 22:37'!
descriptionForPartsBin
	"Answer a description for use in parts bins"

	^ self partName: 	'Spreadsheet' translatedNoop
		categories:		{'GSoC' translatedNoop}
		documentation:	'' translatedNoop! !

!ScrollableSpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/18/2010 11:17'!
cellNumericValueAt: aPoint 
	^spreadsheet cellNumericValueAt: aPoint! !

!ScrollableSpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/18/2010 11:19'!
cellNumericValueAt: aPoint put: aByteString 
	spreadsheet cellNumericValueAt: aPoint put: aByteString ! !

!ScrollableSpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/18/2010 11:17'!
cellValueAt: aPoint 
	^spreadsheet cellValueAt: aPoint! !

!ScrollableSpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/18/2010 11:18'!
cellValueAt: aPoint put: aByteString 
	spreadsheet cellValueAt: aPoint put: aByteString ! !

!ScrollableSpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/29/2010 00:34'!
clearColumn: column
spreadsheet clearColumn: column
! !

!ScrollableSpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/29/2010 00:34'!
clearRow: row
spreadsheet clearRow: row! !

!ScrollableSpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/29/2010 00:34'!
clearTable
spreadsheet clearTable! !

!ScrollableSpreadsheetMorph methodsFor: 'initialize' stamp: 'Richo 6/17/2010 21:44'!
extent: aPoint
| newExtent |
newExtent := (aPoint x max: 126) @ (aPoint y max: 102).
scrollPane extent: newExtent.
super extent: newExtent
! !

!ScrollableSpreadsheetMorph methodsFor: 'halo' stamp: 'Richo 6/18/2010 10:19'!
handlerForBlueButtonDown: anEvent
"It defers the halo to interior only if the click is inside the bounds of the spreadsheet"
^(spreadsheet boundsInWorld containsPoint: anEvent cursorPoint)
	ifTrue: [nil] ifFalse: [self]
! !

!ScrollableSpreadsheetMorph methodsFor: 'initialize' stamp: 'Richo 8/13/2010 00:00'!
initialize
super initialize.
scrollPane := ScrollPane new extent:  620@300; borderWidth: 0; color: (Color r: 0.419 g: 0.419 b: 0.419).
scrollPane scroller addMorph: (spreadsheet := (SpreadsheetMorph rows: 10 columns: 5) position: 2@5).
scrollPane alwaysShowScrollBars: true.
self extent: scrollPane extent; color: Color transparent.
self addMorph: scrollPane.! !

!ScrollableSpreadsheetMorph methodsFor: 'initialize' stamp: 'Richo 6/17/2010 21:18'!
newPlayerInstance
	^spreadsheet newPlayerInstance! !

!ScrollableSpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/17/2010 21:19'!
numberOfColumns
^spreadsheet numberOfColumns! !

!ScrollableSpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/17/2010 21:20'!
numberOfColumns: aNumber
	spreadsheet numberOfColumns: aNumber.
	self updateScrollPane! !

!ScrollableSpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/17/2010 21:17'!
numberOfRows
^spreadsheet numberOfRows! !

!ScrollableSpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/17/2010 21:20'!
numberOfRows: aNumber
	spreadsheet numberOfRows: aNumber.
	self updateScrollPane! !

!ScrollableSpreadsheetMorph methodsFor: 'i/o' stamp: 'Richo 6/29/2010 11:36'!
openCSVFile: filePath separator: aCharacter
	spreadsheet openCSVFile: filePath separator: aCharacter.
	self updateScrollPane ! !

!ScrollableSpreadsheetMorph methodsFor: 'as yet unclassified' stamp: 'Richo 6/29/2010 11:27'!
overwrite
	^spreadsheet overwrite! !

!ScrollableSpreadsheetMorph methodsFor: 'i/o' stamp: 'Richo 6/18/2010 14:28'!
saveCSVFile: filePath separator: aCharacter
	spreadsheet saveCSVFile: filePath separator: aCharacter! !

!ScrollableSpreadsheetMorph methodsFor: 'as yet unclassified' stamp: 'Richo 6/29/2010 11:19'!
setAppend
spreadsheet setAppend! !

!ScrollableSpreadsheetMorph methodsFor: 'as yet unclassified' stamp: 'Richo 6/29/2010 11:28'!
setOverwrite
spreadsheet setOverwrite! !

!ScrollableSpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/17/2010 21:49'!
updateScrollPane
	scrollPane vSetScrollDelta; hSetScrollDelta! !

Morph subclass: #SpreadsheetMorph
	instanceVariableNames: 'numberOfRows numberOfColumns overwrite'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GSoC-Spreadsheet'!

!SpreadsheetMorph class methodsFor: 'viewer categories' stamp: 'Richo 7/26/2010 16:29'!
additionsToViewerCategories
^ #(
(#spreadsheet (
#(command clearTable '')
#(command clearRow '' )
#(command clearColumn '' )
#(slot totalRows '' Number readWrite Player getTotalRows Player setTotalRows:  )
#(slot totalColumns '' Number readWrite Player getTotalColumns Player setTotalColumns:  )
#(slot rowIndex '' Number readWrite Player getRowIndex Player setRowIndex:  )
#(slot columnIndex '' Number readWrite Player getColumnIndex Player setColumnIndex:  )
#(slot currentCharacters '' String readWrite Player getCurrentCharacters Player setCurrentCharacters:  )
#(slot currentNumericValue '' Number readWrite Player getCurrentNumericValue Player setCurrentNumericValue:  )
))

(#'data i/o' (
#(slot writeMode '' WriteMode readWrite Player getWriteMode Player setWriteMode:  )
#(slot csvSeparator '' String readWrite Player getCsvSeparator Player setCsvSeparator:  )
#(slot csvFileName '' String readWrite Player getCsvFileName Player setCsvFileName:  )
#(command importDataFromFile '')
#(command exportDataToFile '')
))

)! !

!SpreadsheetMorph class methodsFor: 'class initialization' stamp: 'Richo 6/29/2010 11:26'!
initialize
"
self initialize.
"
super initialize.
Vocabulary addStandardVocabulary: (SymbolListType new vocabularyName: #WriteMode;
			 symbols: #(#overwrite #append)).! !

!SpreadsheetMorph class methodsFor: 'instance creation' stamp: 'Richo 6/17/2010 16:44'!
rows: numberOfRows columns: numberOfColumns
	^(self basicNew setRows: numberOfRows columns: numberOfColumns) initialize! !

!SpreadsheetMorph methodsFor: 'adding/removing cells' stamp: 'Richo 6/17/2010 18:33'!
addColumn
	numberOfColumns := numberOfColumns + 1.
	self submorphsDo: [:row | row addCell]! !

!SpreadsheetMorph methodsFor: 'adding/removing cells' stamp: 'Richo 6/17/2010 20:48'!
addColumns: aNumber
	aNumber timesRepeat: [self addColumn]! !

!SpreadsheetMorph methodsFor: 'adding/removing cells' stamp: 'Richo 6/18/2010 10:42'!
addRow
	| newRow |
	numberOfRows := numberOfRows + 1.
	newRow := self newRow.
	1 to: numberOfColumns do: [:i | 
		newRow column: i width: (self widthOfCell: i)	
	].
	self addMorphBack: newRow! !

!SpreadsheetMorph methodsFor: 'adding/removing cells' stamp: 'Richo 6/17/2010 20:48'!
addRows: aNumber
	aNumber timesRepeat: [self addRow]! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/18/2010 11:14'!
cellNumericValueAt: aPoint
^(submorphs at: aPoint x) cellNumericValueAt: aPoint y! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/18/2010 11:14'!
cellNumericValueAt: aPoint put: aNumber
 (submorphs at: aPoint x) cellNumericValueAt: aPoint y put: aNumber! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/18/2010 11:11'!
cellValueAt: aPoint
^(submorphs at: aPoint x) cellValueAt: aPoint y! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/18/2010 11:11'!
cellValueAt: aPoint put: aString
 (submorphs at: aPoint x) cellValueAt: aPoint y put: aString! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/29/2010 00:38'!
clearColumn: column
	(column > numberOfColumns or: [column <= 0]) ifTrue: [^self error: 'Invalid column'].
	1 to: numberOfRows do: [:r| self cellValueAt: r@column put: '']

! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/29/2010 00:39'!
clearRow: row
	(row > numberOfRows or: [row <= 0]) ifTrue: [^self error: 'Invalid row'].
	1 to: numberOfColumns do: [:c| self cellValueAt: row@c put: '']

! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/28/2010 23:02'!
clearTable
1 to: numberOfRows do: [:r|
	1 to: numberOfColumns do: [:c|
self cellValueAt: r@c put: ''

	]
]
! !

!SpreadsheetMorph methodsFor: 'cell extent change' stamp: 'Richo 6/17/2010 23:45'!
column: index width: aNumber
self submorphsDo: [:each| each column: index width: aNumber]! !

!SpreadsheetMorph methodsFor: 'halo' stamp: 'Richo 6/17/2010 23:48'!
defersHaloToInteriorMorph: aMorph
^true! !

!SpreadsheetMorph methodsFor: 'initialize' stamp: 'Richo 6/29/2010 11:29'!
initialize
super initialize.
self layoutPolicy: TableLayout new; listDirection: #topToBottom.
self hResizing: #shrinkWrap;
	vResizing: #shrinkWrap.
self color: Color black.
self initializeSubmorphs; setOverwrite
! !

!SpreadsheetMorph methodsFor: 'initialize' stamp: 'Richo 6/17/2010 19:21'!
initializeSubmorphs
numberOfRows timesRepeat: [self addMorph: self newRow]! !

!SpreadsheetMorph methodsFor: 'initialize' stamp: 'Richo 6/17/2010 20:53'!
newPlayerInstance
	^SpreadsheetPlayer newUserInstance! !

!SpreadsheetMorph methodsFor: 'initialize' stamp: 'Richo 6/17/2010 19:21'!
newRow
	^(SpreadsheetRowMorph numberOfCells: numberOfColumns)! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/17/2010 20:46'!
numberOfColumns
^numberOfColumns ! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/17/2010 20:52'!
numberOfColumns: aNumber
| diff |
aNumber <= 0 ifTrue: [^self error: 'Spreadsheet must contain at least one column'].
diff := aNumber - numberOfColumns.
diff > 0 ifTrue: [self addColumns: diff] ifFalse: [self removeColumns: diff negated]
! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/17/2010 20:46'!
numberOfRows
^numberOfRows ! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/17/2010 20:52'!
numberOfRows: aNumber
| diff |
aNumber <= 0 ifTrue: [^self error: 'Spreadsheet must contain at least one row'].
diff := aNumber - numberOfRows.
diff > 0 ifTrue: [self addRows: diff] ifFalse: [self removeRows: diff negated]
! !

!SpreadsheetMorph methodsFor: 'i/o' stamp: 'Richo 7/25/2010 17:34'!
openCSVFile: filePath separator: separator
| values lines rows columns lineValues file textDiffBuilder |
file := FileStream readOnlyFileNamed: filePath.
[	values := OrderedCollection new.
	lines := file contents subStrings: {Character cr. Character lf}.
	columns := 1.
	textDiffBuilder := TextDiffBuilder new.
	lines do: [:line| 
		lineValues := (textDiffBuilder split: line by: separator) collect: [:each | each withBlanksCondensed].
		[lineValues notEmpty and: [lineValues last isEmpty]] whileTrue: [lineValues := lineValues allButLast].
		columns := columns max: lineValues size.
		values add: lineValues.
	].
	[values notEmpty and: [values last isEmpty]] whileTrue: [values removeLast].
	rows := values size.
] ensure: [file close].
values isEmpty ifTrue: [^self "El archivo est vaco"].
self numberOfRows: rows; numberOfColumns: columns.
1 to: rows do: [:r|
	1 to: columns do: [:c |
		self cellValueAt: r@c put: ((values at: r) at: c ifAbsent: '')
	]
]! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/29/2010 11:29'!
overwrite
"Boolean. true if you want to overwrite the file, false if you want to append"
^overwrite! !

!SpreadsheetMorph methodsFor: 'adding/removing cells' stamp: 'Richo 6/17/2010 18:35'!
removeColumn
	numberOfColumns := numberOfColumns - 1.
	self submorphsDo: [:row | row removeCell]! !

!SpreadsheetMorph methodsFor: 'adding/removing cells' stamp: 'Richo 6/17/2010 20:49'!
removeColumns: aNumber
	aNumber timesRepeat: [self removeColumn]! !

!SpreadsheetMorph methodsFor: 'adding/removing cells' stamp: 'Richo 6/17/2010 18:38'!
removeRow
	numberOfRows := numberOfRows - 1.
	self removeMorph: self submorphs last! !

!SpreadsheetMorph methodsFor: 'adding/removing cells' stamp: 'Richo 6/17/2010 20:48'!
removeRows: aNumber
	aNumber timesRepeat: [self removeRow]! !

!SpreadsheetMorph methodsFor: 'i/o' stamp: 'Richo 6/29/2010 11:51'!
saveCSVFile: filePath separator: separator
| file records |
records := (1 to: numberOfRows) collect: [:r | (1 to: numberOfColumns) collect: [:c| self cellValueAt: r@c]].
[records notEmpty and: [(records last select: [:each| each notEmpty]) isEmpty]] whileTrue: [records := records allButLast].
file := self overwrite ifTrue: [FileStream forceNewFileNamed: filePath] ifFalse: [(FileStream fileNamed: filePath) setToEnd].
[records do: [:line |
	line do: [:cell | file nextPutAll: cell] separatedBy: [file nextPut: separator].
	file cr]] ensure: [file close]! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/29/2010 11:29'!
setAppend
overwrite := false! !

!SpreadsheetMorph methodsFor: 'accessing' stamp: 'Richo 6/29/2010 11:29'!
setOverwrite
overwrite := true! !

!SpreadsheetMorph methodsFor: 'private' stamp: 'Richo 6/17/2010 16:45'!
setRows: nRows columns: nColumns
	numberOfRows := nRows.
	numberOfColumns := nColumns! !

!SpreadsheetMorph methodsFor: 'cell extent change' stamp: 'Richo 6/18/2010 10:42'!
widthOfCell: index
	^((submorphs first) submorphs at: index) width! !

Morph subclass: #SpreadsheetRowMorph
	instanceVariableNames: 'numberOfCells'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'GSoC-Spreadsheet'!

!SpreadsheetRowMorph class methodsFor: 'as yet unclassified' stamp: 'Richo 6/17/2010 16:19'!
numberOfCells: aNumber
^(self basicNew setNumberOfCells: aNumber) initialize! !

!SpreadsheetRowMorph methodsFor: 'adding/removing cells' stamp: 'Richo 6/18/2010 10:47'!
addCell
	numberOfCells := numberOfCells + 1.
	self addMorphBack: ((self newTextMorphWithContents: '') height: self height)! !

!SpreadsheetRowMorph methodsFor: 'accessing' stamp: 'Richo 6/29/2010 17:37'!
cellNumericValueAt: index
 ^(submorphs at: index) getNumericValue! !

!SpreadsheetRowMorph methodsFor: 'accessing' stamp: 'Richo 6/28/2010 23:07'!
cellNumericValueAt: index put: aNumber
self cellValueAt: index put: aNumber asString! !

!SpreadsheetRowMorph methodsFor: 'accessing' stamp: 'Richo 6/29/2010 11:40'!
cellValueAt: index
^(submorphs at: index) contents asString! !

!SpreadsheetRowMorph methodsFor: 'accessing' stamp: 'Richo 6/28/2010 23:12'!
cellValueAt: index put: aString
(submorphs at: index) contentsWrapped: aString! !

!SpreadsheetRowMorph methodsFor: 'cell extent change' stamp: 'Richo 6/17/2010 23:46'!
column: index width: aNumber
(submorphs at: index) width: aNumber! !

!SpreadsheetRowMorph methodsFor: 'halo' stamp: 'Richo 6/17/2010 23:48'!
defersHaloToInteriorMorph: aMorph
^true! !

!SpreadsheetRowMorph methodsFor: 'initialize' stamp: 'Richo 6/17/2010 19:18'!
initialize
super initialize.
self layoutPolicy: TableLayout new; listDirection: #leftToRight.
self hResizing: #shrinkWrap;
	vResizing: #shrinkWrap.
self color: Color black.
self initializeSubmorphs! !

!SpreadsheetRowMorph methodsFor: 'initialize' stamp: 'Richo 6/17/2010 18:38'!
initializeSubmorphs
	numberOfCells timesRepeat: [self addMorphBack:(self newTextMorphWithContents: '')]! !

!SpreadsheetRowMorph methodsFor: 'initialize' stamp: 'Richo 8/13/2010 00:01'!
newTextMorphWithContents: aString
	^ GSoCTextMorph new autoFit: false;
		 extent: 100 @ 23;
		 borderWidth: 1;
		rightFlush;
		 backgroundColor: Color white;
		crPassesFocus: true;
		highlightsOnFocus: true;
		 contentsWrapped: aString! !

!SpreadsheetRowMorph methodsFor: 'cell extent change' stamp: 'Richo 6/17/2010 23:47'!
notifyExtentChange: aMorph
| index |
index := self submorphIndexOf: aMorph.
self submorphsDo: [:each | each height: aMorph height].
owner column: index width: aMorph width.! !

!SpreadsheetRowMorph methodsFor: 'adding/removing cells' stamp: 'Richo 6/17/2010 18:36'!
removeCell
	numberOfCells := numberOfCells - 1.
	self removeMorph: self submorphs last! !

!SpreadsheetRowMorph methodsFor: 'private' stamp: 'Richo 6/17/2010 16:20'!
setNumberOfCells: aSmallInteger 
	numberOfCells := aSmallInteger! !

!TextMorph methodsFor: '*GSoC-Spreadsheet' stamp: 'Richo 8/13/2010 00:00'!
setExtentFromHalo: aPoint
	super setExtentFromHalo: aPoint.
	(owner respondsTo: #notifyExtentChange:) ifTrue: [owner notifyExtentChange: self]! !
SpreadsheetMorph initialize!
